Home | History | Annotate | Download | only in src
      1 #!/usr/bin/env bash
      2 # Copyright 2009 The Go Authors. All rights reserved.
      3 # Use of this source code is governed by a BSD-style
      4 # license that can be found in the LICENSE file.
      5 
      6 # See golang.org/s/go15bootstrap for an overview of the build process.
      7 
      8 # Environment variables that control make.bash:
      9 #
     10 # GOROOT_FINAL: The expected final Go root, baked into binaries.
     11 # The default is the location of the Go tree during the build.
     12 #
     13 # GOHOSTARCH: The architecture for host tools (compilers and
     14 # binaries).  Binaries of this type must be executable on the current
     15 # system, so the only common reason to set this is to set
     16 # GOHOSTARCH=386 on an amd64 machine.
     17 #
     18 # GOARCH: The target architecture for installed packages and tools.
     19 #
     20 # GOOS: The target operating system for installed packages and tools.
     21 #
     22 # GO_GCFLAGS: Additional go tool compile arguments to use when
     23 # building the packages and commands.
     24 #
     25 # GO_LDFLAGS: Additional go tool link arguments to use when
     26 # building the commands.
     27 #
     28 # CGO_ENABLED: Controls cgo usage during the build. Set it to 1
     29 # to include all cgo related files, .c and .go file with "cgo"
     30 # build directive, in the build. Set it to 0 to ignore them.
     31 #
     32 # GO_EXTLINK_ENABLED: Set to 1 to invoke the host linker when building
     33 # packages that use cgo.  Set to 0 to do all linking internally.  This
     34 # controls the default behavior of the linker's -linkmode option.  The
     35 # default value depends on the system.
     36 #
     37 # CC: Command line to run to compile C code for GOHOSTARCH.
     38 # Default is "gcc". Also supported: "clang".
     39 #
     40 # CC_FOR_TARGET: Command line to run to compile C code for GOARCH.
     41 # This is used by cgo.  Default is CC.
     42 #
     43 # CXX_FOR_TARGET: Command line to run to compile C++ code for GOARCH.
     44 # This is used by cgo. Default is CXX, or, if that is not set, 
     45 # "g++" or "clang++".
     46 #
     47 # GO_DISTFLAGS: extra flags to provide to "dist bootstrap". Use "-s"
     48 # to build a statically linked toolchain.
     49 
     50 set -e
     51 if [ ! -f run.bash ]; then
     52 	echo 'make.bash must be run from $GOROOT/src' 1>&2
     53 	exit 1
     54 fi
     55 
     56 # Test for Windows.
     57 case "$(uname)" in
     58 *MINGW* | *WIN32* | *CYGWIN*)
     59 	echo 'ERROR: Do not use make.bash to build on Windows.'
     60 	echo 'Use make.bat instead.'
     61 	echo
     62 	exit 1
     63 	;;
     64 esac
     65 
     66 # Test for bad ld.
     67 if ld --version 2>&1 | grep 'gold.* 2\.20' >/dev/null; then
     68 	echo 'ERROR: Your system has gold 2.20 installed.'
     69 	echo 'This version is shipped by Ubuntu even though'
     70 	echo 'it is known not to work on Ubuntu.'
     71 	echo 'Binaries built with this linker are likely to fail in mysterious ways.'
     72 	echo
     73 	echo 'Run sudo apt-get remove binutils-gold.'
     74 	echo
     75 	exit 1
     76 fi
     77 
     78 # Test for bad SELinux.
     79 # On Fedora 16 the selinux filesystem is mounted at /sys/fs/selinux,
     80 # so loop through the possible selinux mount points.
     81 for se_mount in /selinux /sys/fs/selinux
     82 do
     83 	if [ -d $se_mount -a -f $se_mount/booleans/allow_execstack -a -x /usr/sbin/selinuxenabled ] && /usr/sbin/selinuxenabled; then
     84 		if ! cat $se_mount/booleans/allow_execstack | grep -c '^1 1$' >> /dev/null ; then
     85 			echo "WARNING: the default SELinux policy on, at least, Fedora 12 breaks "
     86 			echo "Go. You can enable the features that Go needs via the following "
     87 			echo "command (as root):"
     88 			echo "  # setsebool -P allow_execstack 1"
     89 			echo
     90 			echo "Note that this affects your system globally! "
     91 			echo
     92 			echo "The build will continue in five seconds in case we "
     93 			echo "misdiagnosed the issue..."
     94 
     95 			sleep 5
     96 		fi
     97 	fi
     98 done
     99 
    100 # Test for debian/kFreeBSD.
    101 # cmd/dist will detect kFreeBSD as freebsd/$GOARCH, but we need to
    102 # disable cgo manually.
    103 if [ "$(uname -s)" == "GNU/kFreeBSD" ]; then
    104         export CGO_ENABLED=0
    105 fi
    106 
    107 # Clean old generated file that will cause problems in the build.
    108 rm -f ./runtime/runtime_defs.go
    109 
    110 # Finally!  Run the build.
    111 
    112 echo '##### Building Go bootstrap tool.'
    113 echo cmd/dist
    114 export GOROOT="$(cd .. && pwd)"
    115 GOROOT_BOOTSTRAP=${GOROOT_BOOTSTRAP:-$HOME/go1.4}
    116 if [ ! -x "$GOROOT_BOOTSTRAP/bin/go" ]; then
    117 	echo "ERROR: Cannot find $GOROOT_BOOTSTRAP/bin/go." >&2
    118 	echo "Set \$GOROOT_BOOTSTRAP to a working Go tree >= Go 1.4." >&2
    119 fi
    120 rm -f cmd/dist/dist
    121 GOROOT="$GOROOT_BOOTSTRAP" GOOS="" GOARCH="" "$GOROOT_BOOTSTRAP/bin/go" build -o cmd/dist/dist ./cmd/dist
    122 
    123 # -e doesn't propagate out of eval, so check success by hand.
    124 eval $(./cmd/dist/dist env -p || echo FAIL=true)
    125 if [ "$FAIL" = true ]; then
    126 	exit 1
    127 fi
    128 
    129 echo
    130 
    131 if [ "$1" = "--dist-tool" ]; then
    132 	# Stop after building dist tool.
    133 	mkdir -p "$GOTOOLDIR"
    134 	if [ "$2" != "" ]; then
    135 		cp cmd/dist/dist "$2"
    136 	fi
    137 	mv cmd/dist/dist "$GOTOOLDIR"/dist
    138 	exit 0
    139 fi
    140 
    141 buildall="-a"
    142 if [ "$1" = "--no-clean" ]; then
    143 	buildall=""
    144 	shift
    145 fi
    146 ./cmd/dist/dist bootstrap $buildall $GO_DISTFLAGS -v # builds go_bootstrap
    147 # Delay move of dist tool to now, because bootstrap may clear tool directory.
    148 mv cmd/dist/dist "$GOTOOLDIR"/dist
    149 echo
    150 
    151 if [ "$GOHOSTARCH" != "$GOARCH" -o "$GOHOSTOS" != "$GOOS" ]; then
    152 	echo "##### Building packages and commands for host, $GOHOSTOS/$GOHOSTARCH."
    153 	# CC_FOR_TARGET is recorded as the default compiler for the go tool. When building for the host, however,
    154 	# use the host compiler, CC, from `cmd/dist/dist env` instead.
    155 	CC=$CC GOOS=$GOHOSTOS GOARCH=$GOHOSTARCH \
    156 		"$GOTOOLDIR"/go_bootstrap install -gcflags "$GO_GCFLAGS" -ldflags "$GO_LDFLAGS" -v std cmd
    157 	echo
    158 fi
    159 
    160 echo "##### Building packages and commands for $GOOS/$GOARCH."
    161 CC=$CC_FOR_TARGET "$GOTOOLDIR"/go_bootstrap install $GO_FLAGS -gcflags "$GO_GCFLAGS" -ldflags "$GO_LDFLAGS" -v std cmd
    162 echo
    163 
    164 rm -f "$GOTOOLDIR"/go_bootstrap
    165 
    166 if [ "$1" != "--no-banner" ]; then
    167 	"$GOTOOLDIR"/dist banner
    168 fi
    169